//!parent
//!encoding=utf-8

//****************************************************************************
// @file			LSW CORE LIB: JSON HELPER FUNCTIONS
// @author   	Valentin Schmidt
// @version  	0.1
//****************************************************************************

//--------------------------------------
// JSON_DECODE
//--------------------------------------
function json_decode (me, json){
  var o;
  eval('o='+json);
  return me.json_decode_val(o);
}

//--------------------------------------
// 
//--------------------------------------
function json_decode_val (me, o){ 
  if (o==null) return undefined;
  switch(typeof(o)){            
    case "object":
      if (o instanceof Array){
        var v = list();
        var cnt = o.length;
        for (i=0;i<cnt;i++){
          v.add(me.json_decode_val(o[i]));
        }
      }else{
        var v = propList();
        for (var i in o){
          var p = i;
          v.setAProp(p, me.json_decode_val(o[i]));
        }
      }
      return v;
    default:
      return o;

  }
}

//--------------------------------------
// 
//--------------------------------------
function json_escape_string (me, str){  
  var hash={"\\":"\\\\", "/":"\\/", "\n":"\\n", "\t":"\\t", "\r":"\\r", "\b":"\\b", "\f":"\\f", "\"":"\\\""};
  var patt = "["; for (i in hash) patt+=i;patt+="]";
  return str.replace(RegExp(patt, "g"), function(c){
    return hash[c]
  });
}
